### TIG (c) 2009
### This processes all of the SKPs in a selected folder and deletes any 2D component definitions within them.
### Use with care as it will delete 2D components within components etc within these SKPs.
### It can even remove all the contents of a SKP that was entirely 2D geometry, 
### so it will ask if you want to delete those 'empty' files completely...
### To use, open a new [preferably empty SKP model - although running it shouldn't affect the model you are in]
### In the Ruby Console type batchEraseFlatInstances and press <return>: 
### In the dialog navigate to the folder to be processed and pick any SKP within it and press OK, 
### ALL SKPs in the folder are processed and it IS IRREVERSIBLE - be careful !!!
###
require 'sketchup.rb'
###
def batchEraseFlatInstances()
  model=Sketchup.active_model
  defsEXTG=model.definitions.to_a
  folder=File.dirname(model.path)
  folder=folder.tr("/","\\")if [PLATFORM].grep(/mswin/)==[PLATFORM]
  skp=UI.openpanel("Batch-Erase-Flat-Instances: Choose any SKP, ALL of this folder's SKPs will be processed...",folder,".skp")###
  return nil if not skp
  skp=skp.tr("\\","/")
  folder=File.dirname(skp)
  dirENTS=Dir.entries(folder)
  skps=[]
  Dir.foreach(folder){|file|
    if file.split(".").last and file.split(".").last.downcase=="skp"
      skps<<file
    end#if
  }
  skplist=[]
  skps.each{|skp|
    skplist<<folder+"/"+skp
    model.import(folder+"/"+skp,false)
  }
 model.start_operation("Erase Flat Instances")
  defs=model.definitions
  defs.each{|d|
    bb=d.bounds
    if bb.height==0 or bb.width==0 or bb.depth==0
      d.entities.erase_entities(d.entities.to_a)if not defsEXTG.include?(d)
    end#if
  }
 model.commit_operation
  defsNOW=model.definitions.to_a - defsEXTG ### only those new and perhaps flattened
  ### check if originals match these - some may have gone all together !
  deflist=[]
  defsNOW.each{|d|
    deflist<<folder+"/"+d.name+".skp"
  }
  difs=skplist-deflist
  if difs[0]
    difstxt=difs.to_s
    if UI.messagebox(("These SKPs are entirely 2D and would now be 'empty'\ndo you want to erase the originals ?\n\n"+difstxt),MB_YESNO,"")==6
      ### 6=YES 7=NO
      skplist.each{|file|File.delete(file)}
    else  ### erase only the defs
      deflist.each{|file|File.delete(file)if FileTest.exist?(file)}
    end#if
  end#if
  ### export the defs
  deflist.each{|d|
    dname=File.basename(d,".skp")
    defn=nil
    defsNOW.each{|dd|
      if dd.name==dname
        defn=dd
        break
      end#if
    }
    puts d
    puts File.basename(d)
    if defn and dirENTS.include?(File.basename(d))
      defn.refresh_thumbnail
      defn.save_as(d)
    end#if
  }
  ###
  model.definitions.purge_unused
  puts "Done."
  Sketchup.send_action("SelectSelectionTool:")
  return nil
end#if
###
